package exion.game.runner;

import java.awt.Point;
import java.util.Vector;

/**
 * Title:        RGame
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      exion
 * @author Matey Nenov
 * @version 1.0
 */

public class Enemy extends Point
{
  public final static int IN_HOLE_TIME = 20;

  int [][]  graph = null;
  Table     tableL1 = null;
  Table     tableL2 = null;
  Table     tableL3 = null;
  int       minLength = Integer.MAX_VALUE;
  Point     point = null;
  Point     cpoint = new Point();
  int       gold = 0;

  Point     start = null;

  int       inHoleTimeLeft = 0;
  boolean   isInHole = false;
  Hole      hole = null;

  /**Create new enemy unit.*/
  public Enemy()
  {
    super();
  }

  /**Create new enemy unit.*/
  public Enemy(int x, int y, Table tableL1, Table tableL2, Table tableL3)
  {
    super(x, y);
    start = new Point(x, y);
    point = new Point(x, y);
    this.tableL1 = tableL1;
    this.tableL2 = tableL2;
    this.tableL3 = tableL3;
    graph = new int[tableL1.getWidth()][tableL1.getHeight()];
  }

  /**Move the enemy unit closer to a player.*/
  public synchronized void attack(Vector holes)
  {
    if(isInHole)
    {
      if(inHoleTimeLeft == 0)
      {
        if(holes.contains(hole))
          tableL2.setIcon(x, y, Table.HOLE1);
        else
          tableL2.setIcon(x, y, Table.BACKGROUND);
        tableL3.setIcon(x, y, Table.BACKGROUND);
        move(x, y-1);
        tableL3.setIcon(x, y, Table.ENEMY1);
        isInHole = false;
        hole.empty();
        hole = null;

      }else
      {
        inHoleTimeLeft--;

        return;
      }
    }else if(tableL2.getIcon(x, y+1) == Table.HOLE1)
    {
      for(int i=0; i<holes.size(); i++)
      {
        if(((Hole)holes.elementAt(i)).x == x && ((Hole)holes.elementAt(i)).y == y+1)
        {
          hole = (Hole)holes.elementAt(i);
          break;
        }
      }
      if(hole.isEmpty())
      {
        hole.setEmpty();
        tableL3.setIcon(x, y, Table.BACKGROUND);
        move(x, y+1);
        tableL3.setIcon(x, y, Table.ENEMY1);
        inHoleTimeLeft = IN_HOLE_TIME;
        isInHole = true;
        hole.victim = this;

        return;
      }
      hole = null;
    }

    for(int i=0; i<graph.length; i++)
      for(int j=0; j<graph[0].length; j++)
        graph[i][j] = Integer.MAX_VALUE;
    graph[x][y] = 0;

    minLength = Integer.MAX_VALUE;

    if(tableL1.getIcon(x, y+1) == Table.BACKGROUND)
    {
      point.move(x, y+1);
      cpoint.move(x, y+1);
      search(x, y+1, 0);
    }else
    {
      if(tableL1.getIcon(x-1, y) == Table.BACKGROUND || tableL1.getIcon(x-1, y) == Table.LEDDERS || tableL3.getIcon(x-1, y) == Table.HERO1)
      {
        cpoint.move(x-1, y);
        search(x-1, y, 0);
      }
      if(tableL1.getIcon(x+1, y) == Table.BACKGROUND || tableL1.getIcon(x+1, y) == Table.LEDDERS || tableL3.getIcon(x+1, y) == Table.HERO1)
      {
        cpoint.move(x+1, y);
        search(x+1, y, 0);
      }
      if((tableL1.getIcon(x, y) == Table.LEDDERS) && ((tableL1.getIcon(x, y-1) == Table.LEDDERS) || (tableL1.getIcon(x, y-1) == Table.BACKGROUND)) || tableL3.getIcon(x, y-1) == Table.HERO1)
      {
        cpoint.move(x, y-1);
        search(x, y-1, 0);
      }
      if(((tableL1.getIcon(x, y+1) == Table.BACKGROUND) || (tableL1.getIcon(x, y+1) == Table.LEDDERS)) || tableL3.getIcon(x, y+1) == Table.HERO1)
      {
        cpoint.move(x, y+1);
        search(x, y+1, 0);
      }
    }
      tableL3.setIcon(x, y, Table.BACKGROUND);
    move(point.x, point.y);
    tableL3.setIcon(x, y, Table.ENEMY1);
  }

  /**Unit deths metod in a hole.*/
  public void kill()
  {
    inHoleTimeLeft = 0;
    tableL3.setIcon(x, y, Table.BACKGROUND);
    move(start.x, start.y);
    isInHole = false;
    hole.empty();
    hole = null;
  }

  /**Calculate the best move*/
  private synchronized void search(int x, int y, int length)
  {
    if(graph[x][y] <= ++length)
      return;
    graph[x][y] = length;
    if(length >= minLength)
      return;

    if(tableL3.getIcon(x, y) == Table.HERO1)
    {
      minLength = length;
      point.move(cpoint.x, cpoint.y);

      return;
    }

    if(tableL1.getIcon(x, y+1) == Table.BACKGROUND)
    {
      if(graph[x][y+1] < length)
        return;
      search(x, y+1, length);
    }else
    {
      if((tableL1.getIcon(x-1, y) == Table.BACKGROUND || tableL1.getIcon(x-1, y) == Table.LEDDERS || tableL3.getIcon(x-1, y) == Table.HERO1) && graph[x-1][y] > length)
        search(x-1, y, length);
      if((tableL1.getIcon(x+1, y) == Table.BACKGROUND || tableL1.getIcon(x+1, y) == Table.LEDDERS || tableL3.getIcon(x+1, y) == Table.HERO1) && graph[x+1][y] > length)
        search(x+1, y, length);
      if(((tableL1.getIcon(x, y) == Table.LEDDERS) && ((tableL1.getIcon(x, y-1) == Table.LEDDERS) || (tableL1.getIcon(x, y-1) == Table.BACKGROUND)) || tableL3.getIcon(x, y-1) == Table.HERO1) && graph[x][y-1] > length)
        search(x, y-1, length);
      if(((tableL1.getIcon(x, y+1) == Table.BACKGROUND) || (tableL1.getIcon(x, y+1) == Table.LEDDERS) || tableL3.getIcon(x, y+1) == Table.HERO1) && graph[x][y+1] > length)
        search(x, y+1, length);
    }
  }
}