package exion.game.runner;

import java.awt.Point;
import java.util.Vector;

/**
 * Title:        RGame
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      exion
 * @author Matey Nenov
 * @version 1.0
 */

public class Hole extends Point
{
  public final static int LIFETIME = 30;

  int     life = 0;
  Enemy   victim = null;
  boolean leer = true;
  Table   tableL2 = null;

  Vector holes = null;

  /**Create new hole*/
  public Hole(int x, int y, Vector holes, Table tableL2)
  {
    super(x, y);
    this.tableL2 = tableL2;
    this.holes   = holes;
    tableL2.setIcon(x, y, Table.HOLE1);
    life = LIFETIME;
  }

  /**Empty the hole.*/
  public void empty()
  {
    leer   = true;
    victim = null;
  }

  /**Return true if the hole is empty.*/
  public boolean isEmpty()
  {
    return leer;
  }

  /**Set the empty flag.*/
  public void setEmpty()
  {
    leer = false;
  }

  /**Update the hole state.*/
  public void update()
  {
    if(--life == 0)
    {
      if(victim != null)
        victim.kill();
      tableL2.setIcon(x, y, Table.BACKGROUND);

      holes.removeElement(this);
    }
  }
}