package exion.game.runner;

import java.io.Serializable;

/**
 * Title:        RGame
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      exion
 * @author Matey Nenov
 * @version 1.0
 */

public class Table implements Serializable, Cloneable
{
  private int [][] table;
  private int width;
  private int height;

  public final static int BACKGROUND = 0;
  public final static int BRICKS     = 1;
  public final static int LEDDERS    = 1 << 1;
  public final static int EARTH      = 1 << 2;

  public final static int HERO1      = 1 << 5;
  public final static int HERO2      = 1 << 6;
  public final static int HERO3      = 1 << 7;
  public final static int HERO4      = 1 << 8;

  public final static int ENEMY1     = 1 << 13;
  public final static int ENEMY2     = 1 << 14;
  public final static int ENEMY3     = 1 << 15;
  public final static int ENEMY4     = 1 << 16;

  public final static int GOLD1      = 1 << 21;

  public final static int HOLE1      = 1 << 25;

  public final static int EXIT1      = 1 << 28;

  public final static int INVALID    = 1 << 31;

  /**The serial version UID used by serialization*/
  private static final long serialVersionUID = -1284779312465896859L;

  /**Create table with given rows and columns*/
  public Table(int width, int height)
  {
    table = new int[width][height];
    this.width = width;
    this.height = height;

    for(int i=0; i<width; i++)
      for(int j=0; j<height; j++)
        table[i][j] = 0;
  }

  /**Create a cloning*/
  public Object clone()
  {
    Table t = new Table(width, height);
    for(int i=0; i<width; i++)
      for(int j=0; j<height; j++)
        t.table[i][j] = table[i][j];

    return t;
  }

  /**Return the columns count*/
  public int getWidth()
  {
    return width;
  }

  /**Return the rows count*/
  public int getHeight()
  {
    return height;
  }

  /**Set icon on a square*/
  public void setIcon(int x, int y, int icon)
  {
    table[x][y] = icon;
  }

  /**Return the icon on the given position*/
  public int getIcon(int x, int y)
  {
    try{
      return table[x][y];
    }catch(ArrayIndexOutOfBoundsException aioobe) {return INVALID;}
  }

  /**This function can not be present in future releases*/
  public int[][] getTable()
  {
    return table;
  }
}